unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Process, Unit2, Unit3, Unit4;

type

  { TFormSysFea }

  TFormSysFea = class(TForm)
    BitBtnSambaSwat: TBitBtn;
    BitBtnHilfeLizenz: TBitBtn;
    BitBtnMD5: TBitBtn;
    BitBtnSHA: TBitBtn;
    BitBtnTest1: TBitBtn;
    BitBtnTest2: TBitBtn;
    BitBtnTest3: TBitBtn;
    BitBtnSpeichernPlanung: TBitBtn;
    BitBtnZeichensatz: TBitBtn;
    BitBtnVergleich: TBitBtn;
    BitBtnWaehleDatei: TBitBtn;
    BitBtnGraphik: TBitBtn;
    BitBtnAktSitRep: TBitBtn;
    BitBtnWahl: TBitBtn;
    CheckBoxAktiv1: TCheckBox;
    CheckBoxAktiv2: TCheckBox;
    CheckBoxAktiv3: TCheckBox;
    ComboBoxMonat1: TComboBox;
    ComboBoxMonat2: TComboBox;
    ComboBoxMonat3: TComboBox;
    ComboBoxTag1: TComboBox;
    ComboBoxTag2: TComboBox;
    ComboBoxTag3: TComboBox;
    EditProgramm1: TEdit;
    EditProgramm2: TEdit;
    EditProgramm3: TEdit;
    EditSummeGewaehlt: TEdit;
    EditMD5SHAVergleich: TEdit;
    ListBoxProgramm: TListBox;
    ListBoxSitRep: TListBox;
    OpenDialog: TOpenDialog;
    Panel1: TPanel;
    PanelPlanung1: TPanel;
    PanelPlanung2: TPanel;
    PanelPlanung3: TPanel;
    PanelMD5SHAGewaehlt: TPanel;
    PanelProgrammPlanung: TPanel;
    PanelMD5SUM1: TPanel;
    PanelMD5SummeVergleich: TPanel;
    PanelUptime: TPanel;
    PanelMD5SHASumme: TPanel;
    PanelMD5SUM: TPanel;
    PanelKDESUStart: TPanel;
    PanelIPwlan0: TPanel;
    PanelSuchPfade: TPanel;
    PanelHome: TPanel;
    PanelID: TPanel;
    PanelIPeth0: TPanel;
    PanelSystem: TPanel;
    PanelKernel: TPanel;
    PanelHost: TPanel;
    PanelAnzeige: TPanel;
    PanelSituationsReport: TPanel;
    RadioButtonGleich: TRadioButton;
    RadioButtonUngleich: TRadioButton;
    StatusBar: TStatusBar;
    TimerZeit: TTimer;
    procedure BitBtnAktSitRepClick(Sender: TObject);
    procedure BitBtnGraphikClick(Sender: TObject);
    procedure BitBtnMD5Click(Sender: TObject);
    procedure BitBtnSambaSwatClick(Sender: TObject);
    procedure BitBtnSHAClick(Sender: TObject);
    procedure BitBtnSpeichernPlanungClick(Sender: TObject);
    procedure BitBtnTest1Click(Sender: TObject);
    procedure BitBtnTest2Click(Sender: TObject);
    procedure BitBtnTest3Click(Sender: TObject);
    procedure BitBtnVergleichClick(Sender: TObject);
    procedure BitBtnWaehleDateiClick(Sender: TObject);
    procedure BitBtnWahlClick(Sender: TObject);
    procedure BitBtnZeichensatzClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure TimerZeitTimer(Sender: TObject);

    procedure Indexfehler(Sender: TObject);
    procedure SpeichernProgrammPlanung(Sender: TObject);
    procedure TestProgrammPlanung(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

const Hochkomma    =#39;                                                        // Steuerzeichen
      Zeilenumbruch=#13;
      Escape       =#27;

var
  FormSysFea:               TFormSysFea;
  TextDatei:                TextFile;
  DateiName:                String;
  AktuellerPfad, TextZeile: String;
  AProcess:                 TProcess;
  abgearbeitetDatum:        Array[1..3] of String;

implementation

{ TFormSysFea }

(*--------------------------- Start Programm ---------------------------------*)

procedure TFormSysFea.FormCreate(Sender: TObject);

var i, MonatAktuell: Integer;
    MonatAbgearbeitet: Array[1..3] Of Integer;
    aufgerufen:  boolean;

begin
  AktuellerPfad := ExtractFilePath(ParamStr(0));                                // aktueller Pfad
//  ShowMessage('aktueller Pfad: '+AktuellerPfad);

  ListBoxProgramm.ItemIndex:=0; aufgerufen:=False;
  StatusBar.Panels[0].Text:='Status: Programm gestartet';
  StatusBar.Panels[1].Text:='   Datum: '+FormatDateTime('dd.mm.yyyy',Date);

  AssignFile(TextDatei,AktuellerPfad+'SituationsReport-Skript.sh');             // SituationsReport

  Try
    Rewrite(TextDatei);
    Except
      ShowMessage('SituationsReport-Skript.sh kann nicht anlegen werden!'+Zeilenumbruch+
                  'Die SituationsReport-Daten sind nicht darstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: SitationsReport-Skript.sh nicht anlegbar.';
      Exit;
  end;

  TextZeile:='#!/bin/sh';                                                       // Erzeugung Skript
  WriteLN(TextDatei,TextZeile);
  TextZeile:='# August 2010 - Niklas   ><>';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [uname -s] > '+AktuellerPfad+              'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='uname -s >> '+AktuellerPfad+                    'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [locale] >> '+AktuellerPfad+               'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='locale >> '+AktuellerPfad+                      'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [uname -r] >> '+AktuellerPfad+             'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='uname -r >> '+AktuellerPfad+                    'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [hostname] >> '+AktuellerPfad+             'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='hostname >> '+AktuellerPfad+                    'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [ifconfig eth0] >> '+AktuellerPfad+        'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='ifconfig eth0 >> '+AktuellerPfad+               'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [ifconfig wlan0] >> '+AktuellerPfad+       'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='ifconfig wlan0 >> '+AktuellerPfad+              'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='echo [wlan0-Zeile] ohne Ausschrift >> ' +AktuellerPfad+
                                                              'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [whoami] >> '+AktuellerPfad+               'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='whoami >> '+AktuellerPfad+                      'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [id -u] >> '+AktuellerPfad+                'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='id -u >> '+AktuellerPfad+                       'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [HOME] >> '+AktuellerPfad+                 'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='echo $HOME >> '+AktuellerPfad+                  'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [uptime] >> '+AktuellerPfad+               'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='uptime >> '+AktuellerPfad+                      'SituationsReport';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [release] >> '+AktuellerPfad+              'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='cat /etc/*-release >> '+AktuellerPfad+          'SituationsReport';// "lsb_release -a" auch gut
  WriteLN(Textdatei,TextZeile);

  TextZeile:='echo [SuchPfad] >> '+AktuellerPfad+             'SituationsReport';
  WriteLN(Textdatei,TextZeile);
  TextZeile:='echo $PATH | tr '':'' ''\n'' >> '+AktuellerPfad+'SituationsReport';
  WriteLN(Textdatei,TextZeile);

//  TextZeile:='play '+AktuellerPfad+'Signal.WAV';
//  WriteLN(Textdatei,TextZeile);

  TextZeile:='exit';
  WriteLN(Textdatei,TextZeile);
//  ShowMessage('TextZeile: '+TextZeile);

  CloseFile(TextDatei);

  AProcess := TProcess.Create(nil);                                             // Recht Skript einstellen
  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // verhindert zombie
  AProcess.CommandLine := 'konsole --background-mode -e chmod 777 '+AktuellerPfad+
                          'SituationsReport-Skript.sh';
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;

  AProcess := TProcess.Create(nil);                                             // Achtung! Nicht in Formular auslagern!
  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // verhindert zombie
  AProcess.CommandLine := 'konsole --background-mode -e '+AktuellerPfad+
                          './SituationsReport-Skript.sh';
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;

  Sleep(5000);                                                                  // Zeitschleife - funktioniert!
                                                                                // ProgrammPlanung wird aus Zeitgründen HIER eingebaut!
  AssignFile(TextDatei,AktuellerPfad+'ProgrammPlanung');                        // SituationsReport auswerten
  Try
    Reset(TextDatei);                                                           // Wurde so nicht(!) gefunden!
    Except
      Try
        Rewrite(TextDatei);
        Except
          ShowMessage('ProgrammPlanung-Datei kann nicht angelegt werden!'+Zeilenumbruch+
                      'Die ProgrammPlanung-Daten sind nicht darstellbar.'+Zeilenumbruch+
                      'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
          StatusBar.Panels[0].Text:='Fehler: ProgrammPlanung-Datei nicht anlegbar.';
          Exit;
      end;

      TextZeile:='ProgrammPlanung-Datei bitte nicht editieren!';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='Datei wird vom Programm SysFea erstelt, manipuliert und verarbeitet ><>   Datum: '+
                 FormatDateTime('dd.mm.yyyy',Date);
      WriteLN(Textdatei,TextZeile);

      Textzeile:='-------------------------------------------------------------------------------------------';
      WriteLN(TextDatei,TextZeile);

      TextZeile:='[1] Tag:0; Monat:00; aktiv:n; Datum:tt.mm.jjjj; Programm:1. Programm;';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='[2] Tag:0; Monat:00; aktiv:n; Datum:tt.mm.jjjj; Programm:2. Programm;';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='[3] Tag:0; Monat:00; aktiv:n; Datum:tt.mm.jjjj; Programm:3. Programm;';
      WriteLN(Textdatei,TextZeile);

      Textzeile:='-------------------------------------------------------------------------------------------';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='Planungs-Matrix';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='-------------------------------------------------------------------------------------------';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='Tag		Monat		Abarbeitung';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='-------------------------------------------------------------------------------------------';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='jeden		jeden	==>	taeglich';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='Wochentag	jeden	==>	gewaehlten Wochentag in allen Monaten';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='jeden		Monat	==>	einmal im Monat';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='Wochentag	Monat	==>	jeden gewaehlten Wochentag im gewaehlten Monat';
      WriteLN(TextDatei,TextZeile);
      TextZeile:='-------------------------------------------------------------------------------------------';
      WriteLN(TextDatei,TextZeile);

      CloseFile(TextDatei);
  end;

  AssignFile(TextDatei,AktuellerPfad+'SituationsReport');                       // SituationsReport auswerten
  Try
    Reset(TextDatei);                                                           // Wurde so nicht(!) gefunden!
    Except
      ShowMessage('SituationsReport-Datei kann nicht gelesen werden!'+Zeilenumbruch+
                  'Die SituationsReport-Daten sind nicht darstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: SituationsReport-Datei nicht lesbar.';
      Exit;
  end;

  Repeat
    ReadLN(TextDatei,TextZeile);

    If Pos('[uname -s]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelSystem.Caption  :='System / Lokal.: '+TextZeile;
      End;
    If Pos('[locale]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelSystem.Caption  :=PanelSystem.Caption+' / '+Copy(TextZeile,6,11);
      End;
    If Pos('[uname -r]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelKernel.Caption  :='KernelVersion  : '+TextZeile;
      End;
    If Pos('[hostname]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelHost.Caption    :='HostName       : '+TextZeile;
       End;
    If Pos('[ifconfig eth0]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile); ReadLN(TextDatei,TextZeile);
        If Pos('inet Adresse',TextZeile)<>0 Then
          PanelIPeth0.Caption  :='IP-Adr. eth0     : '+Copy(TextZeile,24,15)
                                            Else
          PanelIPeth0.Caption  :='IP-Adr. eth0     : keine';
      End;
    If Pos('[ifconfig wlan0]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile); ReadLN(TextDatei,TextZeile);
        If Pos('inet Adresse',TextZeile)<>0 Then
          PanelIPwlan0.Caption  :='IP-Adr. wlan0   : '+Copy(TextZeile,24,15)
                                            Else
          PanelIPwlan0.Caption  :='IP-Adr. wlan0   : keine';
      End;
    If Pos('[whoami]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelID.Caption         :='Identitaet / ID : '+TextZeile;
       End;
    If Pos('[id -u]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelID.Caption:=PanelID.Caption+' / '+TextZeile;
      End;
    If Pos('[uptime]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        i:=Pos('up',TextZeile);
        TextZeile:=Copy(Textzeile,i+2,6);
        PanelUptime.Caption     :='AnmeldeZeit   : '+TextZeile;
      End;
    If Pos('[HOME]',TextZeile)<>0 Then
      Begin
        ReadLN(TextDatei,TextZeile);
        PanelHome.Caption    :='HOME-Verz.     : '+TextZeile;
      End;
  Until Pos('[release]',TextZeile)<>0;

  ListBoxSitRep.Clear;

  TextZeile:='==> Release <==';
  ListBoxSitRep.Items.Add(TextZeile);
  Repeat
    ReadLN(TextDatei,TextZeile);
    If Pos('[SuchPfad]',TextZeile)=0 Then ListBoxSitRep.Items.Add(TextZeile);
  Until Pos('[SuchPfad]',TextZeile)<>0;
  TextZeile:='';
  ListBoxSitRep.Items.Add(TextZeile);

  TextZeile:='==> SuchPfade <==';
  ListBoxSitRep.Items.Add(TextZeile);
  While not EOF(TextDatei) Do
    Begin
      ReadLN(TextDatei,TextZeile);
      ListBoxSitRep.Items.Add(TextZeile);
    end;
  CloseFile(TextDatei);

  AssignFile(TextDatei,'/etc/samba/smb.conf');                                  // SAMBA
  Try
    Reset(TextDatei);
  Except
    ShowMessage('Die Datei /etc/samba/smb.conf kann nicht gelesen werden!'+Zeilenumbruch+
                'Bitte samba-Installation pruefen und nochmals versuchen!');
    StatusBar.Panels[0].Text:='Fehler: smb.conf nicht lesbar.';
    Exit;
  end;

  TextZeile:='';
  ListBoxSitRep.Items.Add(TextZeile);
  TextZeile:='==> smb.conf <==';
  ListBoxSitRep.Items.Add(TextZeile);
  While not EOF(TextDatei) Do
    Begin
      ReadLN(TextDatei,TextZeile);
      ListBoxSitRep.Items.Add(TextZeile);
    end;

  CloseFile(TextDatei);

  AssignFile(TextDatei,AktuellerPfad+'MD5Summe');                               // MD5-Summen einer Sitzung gespeichert
  Try
    Rewrite(TextDatei);
      Except
        ShowMessage('Die MD5Summe-Datei kann nicht angelegt werden!'+Zeilenumbruch+
                    'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
        StatusBar.Panels[0].Text:='Fehler: MD5Summe-Datei nicht anlegbar.';
        Exit;
  end;
  CloseFile(TextDatei);

  AssignFile(TextDatei,AktuellerPfad+'ProgrammPlanung');                        // ProgrammPlanung auswerten
  Try
    Reset(TextDatei);                                                           // Wurde so nicht(!) gefunden!
    Except
      ShowMessage('ProgrammPlanung-Datei kann nicht gelesen werden!'+Zeilenumbruch+
                  'Die ProgrammPlanung-Daten sind nicht darstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: ProgrammPlanung-Datei nicht lesbar.';
      Exit;
  end;

  While Not EOF(Textdatei) Do                                                   // ProgrammPlanung
    Begin
      ReadLN(TextDatei,TextZeile);

      If Pos('[1]',TextZeile)<>0 Then                                           // 1. Zeile
        Begin
          i:=Pos('Tag:',TextZeile);
          if i<>0 Then
            ComboBoxTag1.ItemIndex:=StrToInt(TextZeile[i+4])
                  Else IndexFehler(Sender);
          i:=Pos('Monat:',TextZeile);
          if i<>0 Then
            ComboBoxMonat1.ItemIndex:=StrToInt(TextZeile[i+6]+TextZeile[i+7])
                  Else IndexFehler(Sender);
          i:=Pos('aktiv:',TextZeile);
          if i<>0 Then
            If TextZeile[i+6]='n' Then CheckBoxAktiv1.State:=cbUnchecked
                                  Else
            If TextZeile[i+6]='j' Then CheckBoxAktiv1.State:=cbChecked
                                  Else IndexFehler(Sender);
          i:=Pos('Datum:',TextZeile);
          if i=0 Then IndexFehler(Sender);
          abgearbeitetDatum[1]:=Copy(TextZeile,i+6,10);
          i:=Pos('Programm:',TextZeile);
          if i=0 Then IndexFehler(Sender);
          EditProgramm1.Text:='';
          While Textzeile[i+9]<>';' Do
            Begin
              EditProgramm1.Text:=EditProgramm1.Text+TextZeile[i+9];
              i:=Succ(i);
            end;
      End;

      If Pos('[2]',TextZeile)<>0 Then                                           // 2. Zeile
        Begin
          i:=Pos('Tag:',TextZeile);
          if i<>0 Then
            ComboBoxTag2.ItemIndex:=StrToInt(TextZeile[i+4])
                  Else IndexFehler(Sender);
          i:=Pos('Monat:',TextZeile);
          if i<>0 Then
            ComboBoxMonat2.ItemIndex:=StrToInt(TextZeile[i+6]+TextZeile[i+7])
                  Else IndexFehler(Sender);
          i:=Pos('aktiv:',TextZeile);
          if i<>0 Then
            If TextZeile[i+6]='n' Then CheckBoxAktiv2.State:=cbUnchecked
                                  Else
            If TextZeile[i+6]='j' Then CheckBoxAktiv2.State:=cbChecked
                                  Else IndexFehler(Sender);
          i:=Pos('Datum:',TextZeile);
          if i=0 Then IndexFehler(Sender);
          abgearbeitetDatum[2]:=Copy(TextZeile,i+6,10);
          i:=Pos('Programm:',TextZeile);
          if i=0 Then IndexFehler(Sender);
          EditProgramm2.Text:='';
          While Textzeile[i+9]<>';' Do
            Begin
              EditProgramm2.Text:=EditProgramm2.Text+TextZeile[i+9];
              i:=Succ(i);
            end;
      End;

      If Pos('[3]',TextZeile)<>0 Then                                           // 3. Zeile
        Begin
          i:=Pos('Tag:',TextZeile);
          if i<>0 Then
            ComboBoxTag3.ItemIndex:=StrToInt(TextZeile[i+4])
                  Else IndexFehler(Sender);
          i:=Pos('Monat:',TextZeile);
          if i<>0 Then
            ComboBoxMonat3.ItemIndex:=StrToInt(TextZeile[i+6]+TextZeile[i+7])
                  Else IndexFehler(Sender);
          i:=Pos('aktiv:',TextZeile);
          if i<>0 Then
            If TextZeile[i+6]='n' Then CheckBoxAktiv3.State:=cbUnchecked
                                  Else
            If TextZeile[i+6]='j' Then CheckBoxAktiv3.State:=cbChecked
                                  Else IndexFehler(Sender);
            i:=Pos('Datum:',TextZeile);
            if i=0 Then IndexFehler(Sender);
            abgearbeitetDatum[3]:=Copy(TextZeile,i+6,10);
            i:=Pos('Programm:',TextZeile);
            if i=0 Then IndexFehler(Sender);
            EditProgramm3.Text:='';
            While Textzeile[i+9]<>';' Do
              Begin
                EditProgramm3.Text:=EditProgramm3.Text+TextZeile[i+9];
                i:=Succ(i);
              end;
        End;
    End;
//  If abgearbeitetKZ[3]=True Then Textzeile:='True'
//                            Else Textzeile:='False';
//  ShowMessage('abgearbeitetKZ: '+TextZeile);
//  ShowMessage('abgearbeitetDatum: '+abgearbeitetDatum[1]);

  CloseFile(TextDatei);

  i:=0;                                                                         // Auswertung ProgrammPlanung
  If ((CheckBoxAktiv1.State=cbChecked) And (ComboBoxTag1.ItemIndex=0) And       // jeden		jeden	==>	taeglich
      (ComboBoxMonat1.ItemIndex=0) And
      (abgearbeitetDatum[1]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=1 Else
  If ((CheckBoxAktiv2.State=cbChecked) And (ComboBoxTag2.ItemIndex=0) And
      (ComboBoxMonat2.ItemIndex=0) And
      (abgearbeitetDatum[2]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=2 Else
  If ((CheckBoxAktiv3.State=cbChecked) And (ComboBoxTag3.ItemIndex=0) And
      (ComboBoxMonat3.ItemIndex=0) And
      (abgearbeitetDatum[3]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=3;
  If i<>0 Then
    Begin
      If i=1 Then BitBtnTest1Click(Sender) Else
      If i=2 Then BitBtnTest2Click(Sender) Else
      If i=3 Then BitBtnTest3Click(Sender);
      abgearbeitetDatum[i]:=FormatDateTime('dd.mm.yyyy',Date);
      aufgerufen:=True;                                                         // Speichern Aufruf
    End;

  i:=0;
  If ((CheckBoxAktiv1.State=cbChecked) And (ComboBoxTag1.ItemIndex<>0) And      // Wochentag	        jeden	==>	gewaeehlten Wochentag in allen Monaten
      (ComboBoxMonat1.ItemIndex=0) And
      (ComboBoxTag1.ItemIndex=DayOfWeek(Date)) And
      (abgearbeitetDatum[1]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=1 Else
  If ((CheckBoxAktiv2.State=cbChecked) And (ComboBoxTag2.ItemIndex<>0) And
      (ComboBoxMonat2.ItemIndex=0) And
      (ComboBoxTag2.ItemIndex=DayOfWeek(Date)) And
      (abgearbeitetDatum[2]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=2 Else
  If ((CheckBoxAktiv3.State=cbChecked) And (ComboBoxTag3.ItemIndex<>0) And
      (ComboBoxMonat3.ItemIndex=0) And
      (ComboBoxTag3.ItemIndex=DayOfWeek(Date)) And
      (abgearbeitetDatum[3]<>FormatDateTime('dd.mm.yyyy',Date))) Then i:=3;
  If i<>0 Then
    Begin
      If i=1 Then BitBtnTest1Click(Sender) Else
      If i=2 Then BitBtnTest2Click(Sender) Else
      If i=3 Then BitBtnTest3Click(Sender);
      abgearbeitetDatum[i]:=FormatDateTime('dd.mm.yyyy',Date);
      aufgerufen:=True;                                                         // Speichern Aufruf
    end;
//  ShowMessage('i: '+IntToStr(i)+'   Wochentag: '+IntToStr(DayOfWeek(Date))+'   TagIndex2: '+IntToStr(ComboBoxTag2.ItemIndex));

  TextZeile:=FormatDateTime('dd.mm.yyyy',Date);                                 // aktueller Monat
  MonatAktuell:=StrToInt(Copy(TextZeile,4,2));

  For i:=1 To 3 Do                                                              // abgearbeiteter Monat
    If Copy(abgearbeitetDatum[i],4,2) <> 'mm' Then
      MonatAbgearbeitet[i]:=StrToInt(Copy(abgearbeitetDatum[i],4,2))
                                                     Else
      MonatAbgearbeitet[i]:=13;
//  ShowMessage('MonatAktuell: '+IntToStr(MonatAktuell)+'  MonatAbgearbeitet 3: '+IntToStr(MonatAbgearbeitet[3]));

  I:=0;
  If ((CheckBoxAktiv1.State=cbChecked) And (ComboBoxTag1.ItemIndex=0) And       //jeden		Monat	==>	einmal im Monat
      (ComboBoxMonat1.ItemIndex<>0) And
      (ComboBoxMonat1.ItemIndex=MonatAktuell) And
      (ComboBoxMonat1.Itemindex<>MonatAbgearbeitet[1])) Then i:=1 Else
  If ((CheckBoxAktiv2.State=cbChecked) And (ComboBoxTag2.ItemIndex=0) And
      (ComboBoxMonat2.ItemIndex<>0) And
      (ComboBoxMonat2.ItemIndex=MonatAktuell) And
      (ComboBoxMonat2.Itemindex<>MonatAbgearbeitet[2])) Then i:=2 Else
  If ((CheckBoxAktiv3.State=cbChecked) And (ComboBoxTag3.ItemIndex=0) And
      (ComboBoxMonat3.ItemIndex<>0) And
      (ComboBoxMonat3.ItemIndex=MonatAktuell) And
      (ComboBoxMonat3.Itemindex<>MonatAbgearbeitet[3])) Then i:=3;
  If i<>0 Then
    Begin
      If i=1 Then BitBtnTest1Click(Sender) Else
      If i=2 Then BitBtnTest2Click(Sender) Else
      If i=3 Then BitBtnTest3Click(Sender);
      abgearbeitetDatum[i]:=FormatDateTime('dd.mm.yyyy',Date);
      aufgerufen:=True;                                                         // Speichern Aufruf
    end;

  I:=0;
  If ((CheckBoxAktiv1.State=cbChecked) And (ComboBoxTag1.ItemIndex<>0) And      //  Wochentag	Monat	==>	jeden gewaehlten Wochentag im gewaehlten Monat
      (ComboBoxMonat1.ItemIndex<>0) And
      (ComboBoxTag1.ItemIndex=DayOfWeek(Date)) And
      (ComboBoxMonat1.ItemIndex=MonatAktuell) And
      (ComboBoxMonat1.Itemindex<>MonatAbgearbeitet[1])) Then i:=1 Else
  If ((CheckBoxAktiv2.State=cbChecked) And (ComboBoxTag2.ItemIndex<>0) And
      (ComboBoxTag2.ItemIndex=DayOfWeek(Date)) And
      (ComboBoxMonat2.ItemIndex<>0) And
      (ComboBoxMonat2.ItemIndex=MonatAktuell) And
      (ComboBoxMonat2.Itemindex<>MonatAbgearbeitet[2])) Then i:=2 Else
  If ((CheckBoxAktiv3.State=cbChecked) And (ComboBoxTag3.ItemIndex<>0) And
      (ComboBoxMonat3.ItemIndex<>0) And
      (ComboBoxTag3.ItemIndex=DayOfWeek(Date)) And
      (ComboBoxMonat3.ItemIndex=MonatAktuell) And
      (ComboBoxMonat3.Itemindex<>MonatAbgearbeitet[3])) Then i:=3;
  If i<>0 Then
    Begin
      If i=1 Then BitBtnTest1Click(Sender) Else
      If i=2 Then BitBtnTest2Click(Sender) Else
      If i=3 Then BitBtnTest3Click(Sender);
      abgearbeitetDatum[i]:=FormatDateTime('dd.mm.yyyy',Date);
      aufgerufen:=True;                                                         // Speichern Aufruf
    end;



  If aufgerufen Then SpeichernProgrammPlanung(Sender);                          // Speichern ProgrammPlanung

//  Erase(TextDatei);                                                           // Stabiler, sie bleiben stehen!
//  AssignFile(TextDatei,AktuellerPfad+'SituationsReport-Skript.sh');
//  Erase(TextDatei);

  BitBtnMD5.Enabled:=False;
  BitBtnSHA.Enabled:=False;
end;

(*--------------------------- IndexFehler bei ProgrammPlanung ----------------*)

Procedure TFormSysFea.IndexFehler(Sender: TObject);
Begin
  ShowMessage('ProgrammPlanung-Datei kann nicht vollstaendig verarbeitet werden!'+Zeilenumbruch+
              'Die ProgrammPlanung-Daten sind nicht vollstaendig darstellbar.'+Zeilenumbruch+
              'Bitte Inhalt ProgrammPlanung-Datei pruefen, speichern oder loeschen und nochmals versuchen!');
  StatusBar.Panels[0].Text:='Fehler: Inhalt ProgrammPlanung-Datei nicht vollstaendig verarbeitbar.';
end;

(*--------------------------- Zeit -------------------------------------------*)

procedure TFormSysFea.TimerZeitTimer(Sender: TObject);
begin
  StatusBar.Panels[2].Text:='Zeit: '+FormatDateTime('hh.mm.ss',Time);
end;

(*--------------------------- Aktualisieren SituationsReport -----------------*)

procedure TFormSysFea.BitBtnAktSitRepClick(Sender: TObject);
begin
  FormCreate(Sender);
  StatusBar.Panels[0].Text:='Status: SitationsReport aktualisiert';
end;

(*--------------------------- Anzeige Hilfe / Lizenz -------------------------*)

procedure TFormSysFea.FormDblClick(Sender: TObject);
begin
  StatusBar.Panels[0].Text:='Status: Anzeige Hilfe/Lizenz';
  FormInfo.ShowModal;
end;

(*--------------------------- Aufruf Programm --------------------------------*)

procedure TFormSysFea.BitBtnWahlClick(Sender: TObject);

var ProgrammName: String;
    i:            Integer;

begin
  TextZeile:=ListBoxProgramm.Items[ListBoxProgramm.ItemIndex];                  // Auswahl Programm

  ProgrammName:=''; i:=1;
  While TextZeile[i]<>' ' do
    Begin
      ProgrammName:=ProgrammName+Textzeile[i];
      i:=Succ(i);
    End;
  StatusBar.Panels[0].Text:='Status: Programm gewaehlt: '+Copy(ListBoxProgramm.Items[ListBoxProgramm.ItemIndex],1,10);

  If (ProgrammName='mc') Or (ProgrammName='iptraf') Or (ProgrammName='lshw') Or
     (ProgrammName='shutdown') Then
    Begin                                                                       // nur bei Konsole!
      AssignFile(TextDatei,AktuellerPfad+'SysFea-Skript.sh');

      Try
        Rewrite(TextDatei);
        Except
          ShowMessage('SysFea-Skript.sh kann nicht anlegen werden!'+Zeilenumbruch+
                      'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
          StatusBar.Panels[0].Text:='Fehler: SysFea-Skript.sh nicht anlegbar.';
          Exit;
      end;

      TextZeile:='#!/bin/sh';
      WriteLN(TextDatei,TextZeile);

      TextZeile:='# LinuxFanatic 16.04.2010 - Thomas wird 39  ><>';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='clear';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='ExecAsRoot=/usr/lib/kde4/libexec/kdesu';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='if [ "$(id -u)" != "0" ]; then';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='echo "Start des Programmes mit root-Rechten!"';
      WriteLN(Textdatei,TextZeile);

//      TextZeile:='exec $ExecAsRoot "sh $(readlink -f $0)"';
      TextZeile:='exec $ExecAsRoot "$(readlink -f $0)"';                        // ab 2011.1
      WriteLN(Textdatei,TextZeile);

      TextZeile:='exit';
      WriteLN(Textdatei,TextZeile);

      TextZeile:='fi';
      WriteLN(Textdatei,TextZeile);

      If ProgrammName='lshw' Then
        If MessageDlg('Soll die Anzeige der Hardware im graphischen Modus gestartet werden?'+#13+
                        '(Sonst als Konsole-Ausgabe - ausfuehrlicher!)',
                         mtInformation, [mbYes, mbNo],0) = mrYes Then           // lshw im graph. Modus
          TextZeile:='gtk-lshw'                                  Else
          TextZeile:='konsole -noclose -e '+ProgrammName
                             Else
        If ProgrammName='shutdown' Then TextZeile:= ProgrammName+' -h now'      // shutdown
                                   Else
         TextZeile:='konsole -noclose -e '+ProgrammName;                        // mc; iptraf; lshw
//      ShowMessage('TextZeile: '+TextZeile);
      WriteLN(TextDatei,TextZeile);

      TextZeile:='exit';
      WriteLN(Textdatei,TextZeile);

      CloseFile(TextDatei);

      AProcess := TProcess.Create(nil);                                         // Recht Skript einstellen
      AProcess.Options := AProcess.Options + [poWaitOnExit];                    // verhindert zombie
      AProcess.CommandLine := 'konsole --background-mode -e chmod 777 '+
                              AktuellerPfad+'SysFea-Skript.sh';
      AProcess.Execute;                                                         // eigentlicher Aufruf
      AProcess.Free;

      TextZeile:='konsole --background-mode -e '+AktuellerPfad+
                             'SysFea-Skript.sh'
    end                        Else
      TextZeile:='xdg-su -c '+ProgrammName;                                     // Programmaufruf GUI-Programm

  AProcess := TProcess.Create(nil);                                             // Aufruf Skript
//      AStringList := TStringList.Create;

  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // verhindert zombie
//    AProcess.CommandLine :='konsole -e '+AktuellerPfad+                           // Test!
//    AProcess.Options := AProcess.Options + [poWaitOnExit, poUsePipes];            // Möglichkeit, dass Programm soll nicht weiterläuft
  AProcess.CommandLine:=TextZeile;

  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;

//  AStringList.LoadFromStream(AProcess.Output);
//  AStringList.SaveToFile(AktuellerPfad+'output.txt');                           // Kommt nur bei Programmen, die was ausgeben z.B. lazarus!
//  AStringList.Free;
end;

(*--------------------------- GraphiKartenTest -------------------------------*)

procedure TFormSysFea.BitBtnGraphikClick(Sender: TObject);
begin
  AProcess := TProcess.Create(nil);
  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // verhindert zombie
//  AProcess.CommandLine := 'konsole --background-mode -e glxgears';
  AProcess.CommandLine := 'konsole -e glxgears -info';                          // mit Informationen!
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;
  StatusBar.Panels[0].Text:='Status: GraphikKartenTest gewaehlt';
end;

(*--------------------------- samba-swat -------------------------------------*)

procedure TFormSysFea.BitBtnSambaSwatClick(Sender: TObject);
begin
  AProcess := TProcess.Create(nil);
  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // verhindert zombie
  AProcess.CommandLine := '/usr/bin/firefox http://localhost:901';
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;
  StatusBar.Panels[0].Text:='Status: samba-swat gewaehlt';
end;

(*--------------------------- ASCII-Zeichensatz ------------------------------*)

procedure TFormSysFea.BitBtnZeichensatzClick(Sender: TObject);
begin
  StatusBar.Panels[0].Text:='Status: Anzeige ASCII-Zeichensatz gewaehlt';
  FormASCII.ShowModal;
end;

(*--------------------------- Waehle Datei -----------------------------------*)

procedure TFormSysFea.BitBtnWaehleDateiClick(Sender: TObject);

var i:         ShortInt;

begin
  If OpenDialog.Execute Then
    Begin
//     ShowMessage('OpenDialog.FileName: '+OpenDialog.FileName);
      RadioButtonGleich.Enabled  :=False;
      RadioButtonUngleich.Enabled:=False;
      StatusBar.Panels[0].Text:='Status: Datei gewaehlt: '+OpenDialog.FileName;

      If not FileExists(OpenDialog.FileName) Then                               // Datei nicht vorhanden (SicherheitsAbfrage)
        Begin
          ShowMessage('Fehler: Es muss eine gueltige Datei gewaehlt sein!');
          StatusBar.Panels[0].Text:='Logik-Fehler: Keine gueltige Datei gewaehlt.';
          Exit;
        End;

      DateiName:=OpenDialog.FileName;
      For i:=1 To Length(DateiName) Do                                          // Leerzeichen "jokern"
        If DateiName[i]=' ' Then DateiName[i]:='*';
      BitBtnMD5.Enabled:=True;
      BitBtnSHA.Enabled:=True;
    end                 Else
      StatusBar.Panels[0].Text:='Hinweis: DateiDialog abgebrochen.';
end;

(*--------------------------- MD5-Summe --------------------------------------*)

procedure TFormSysFea.BitBtnMD5Click(Sender: TObject);
begin
  StatusBar.Panels[0].Text:=StatusBar.Panels[0].Text+' - MD5-Summe gewaehlt';
  AssignFile(TextDatei,AktuellerPfad+'Sum-Skript.sh');

  Try
    Rewrite(TextDatei);
    Except
      ShowMessage('Sum-Skript.sh kann nicht anlegen werden!'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: Sum-Skript.sh nicht anlegbar.';
      Exit;
  end;

  TextZeile:='#!/bin/sh';
  WriteLN(TextDatei,TextZeile);

  TextZeile:='# 15.01.2001 unvergessen';
  WriteLN(TextDatei,TextZeile);

  TextZeile:='md5sum '+DateiName+' >> '+AktuellerPfad+'MD5Summe';
  WriteLN(Textdatei,TextZeile);
                                                                                // Genau hier müsste gewartet werden bis Datei erstellt ist!
  TextZeile:='exit';
  WriteLN(Textdatei,TextZeile);

  CloseFile(TextDatei);

  AProcess := TProcess.Create(nil);                                             // Recht Skript einstellen
//      AProcess.Options := AProcess.Options + [poWaitOnExit];                    // verhindert zombie
  AProcess.CommandLine := 'konsole --background-mode -e chmod 777 '+
                          AktuellerPfad+'Sum-Skript.sh';
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;

  EditSummeGewaehlt.Text:='Bei leer - bitte Vorgang wiederholen!';

  FormProcess.ShowModal;                                                        //Berechnung der MD5-Summe

  AssignFile(TextDatei,AktuellerPfad+'MD5Summe');
  Try
    Reset(TextDatei);
    Except
      ShowMessage('MD5Summe-Datei kann nicht gelesen werden!'+Zeilenumbruch+
                  'Die MD5-Summe ist nicht darstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: MD5Summe-Datei nicht lesbar.';
      Exit;
  end;

  While not EOF(TextDatei) Do ReadLN(TextDatei,TextZeile);
  CloseFile(TextDatei);

  EditSummeGewaehlt.Text:=Copy(TextZeile,1,32);                                 // Anzeige MD5-Summe

//      Erase(TextDatei);                                                         // Stabiler, sie bleiben stehen!
//      AssignFile(TextDatei,AktuellerPfad+'MD5Sum-Skript.sh');
//      Erase(TextDatei);
end;

(*--------------------------- SHA-Summe --------------------------------------*)

procedure TFormSysFea.BitBtnSHAClick(Sender: TObject);

begin
  StatusBar.Panels[0].Text:=StatusBar.Panels[0].Text+' - SHA-Summe gewaehlt';
  AssignFile(TextDatei,AktuellerPfad+'Sum-Skript.sh');

  Try
    Rewrite(TextDatei);
    Except
      ShowMessage('Sum-Skript.sh kann nicht anlegen werden!'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: Sum-Skript.sh nicht anlegbar.';
      Exit;
  end;

  TextZeile:='#!/bin/sh';
  WriteLN(TextDatei,TextZeile);

  TextZeile:='# 02.08.2007 unvergessen';
  WriteLN(TextDatei,TextZeile);

  TextZeile:='shasum -a 256 '+DateiName+' >> '+AktuellerPfad+'SHASumme';
  WriteLN(Textdatei,TextZeile);
                                                                                // Genau hier müsste gewartet werden bis Datei erstellt ist!
  TextZeile:='exit';
  WriteLN(Textdatei,TextZeile);

  CloseFile(TextDatei);

  AProcess := TProcess.Create(nil);                                             // Recht Skript einstellen
//      AProcess.Options := AProcess.Options + [poWaitOnExit];                    // verhindert zombie
  AProcess.CommandLine := 'konsole --background-mode -e chmod 777 '+
                          AktuellerPfad+'Sum-Skript.sh';
  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;

  EditSummeGewaehlt.Text:='Bei leer - bitte Vorgang wiederholen!';

  FormProcess.ShowModal;                                                        //Berechnung der SHA-Summe

  AssignFile(TextDatei,AktuellerPfad+'SHASumme');
  Try
    Reset(TextDatei);
    Except
      ShowMessage('SHASumme-Datei kann nicht gelesen werden!'+Zeilenumbruch+
                  'Die MD5-Summe ist nicht darstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
      StatusBar.Panels[0].Text:='Fehler: SHASumme-Datei nicht lesbar.';
      Exit;
  end;

  While not EOF(TextDatei) Do ReadLN(TextDatei,TextZeile);
  CloseFile(TextDatei);

  EditSummeGewaehlt.Text:=Copy(TextZeile,1,64);                                 // Anzeige SHA-Summe

//      Erase(TextDatei);                                                         // Stabiler, sie bleiben stehen!
//      AssignFile(TextDatei,AktuellerPfad+'MD5Sum-Skript.sh');
//      Erase(TextDatei);

end;

(*--------------------------- Vergleich Summen ------    ---------------------*)

procedure TFormSysFea.BitBtnVergleichClick(Sender: TObject);
begin
  If EditSummeGewaehlt.Text=EditMD5SHAVergleich.Text Then
    Begin
      RadioButtonGleich.Enabled  :=True;
      RadioButtonGleich.Checked  :=True;
      RadioButtonUngleich.Enabled:=False;
      RadioButtonUngleich.Checked:=False;
    end                                                   Else
    Begin
      RadioButtonUngleich.Enabled:=True;
      RadioButtonUngleich.Checked:=True;
      RadioButtonGleich.Enabled  :=False;
      RadioButtonGleich.Checked  :=False;
    end;
  StatusBar.Panels[0].Text:='Status: MD5/SHA-Summen verglichen';
end;

(*--------------------------- Test ProgrammPlanung ---------------------------*)

procedure TFormSysFea.TestProgrammPlanung(Sender: TObject);
Begin
  AProcess := TProcess.Create(nil);                                             // Aufruf Skript

  AProcess.CommandLine:=TextZeile;

  AProcess.Execute;                                                             // eigentlicher Aufruf
  AProcess.Free;
End;

(*--------------------------- Start ProgrammPlanung --------------------------*)

procedure TFormSysFea.BitBtnTest1Click(Sender: TObject);
begin
  TextZeile:='konsole --background-mode -e '+EditProgramm1.Text;                // Programmaufruf
  TestProgrammPlanung(Sender);
end;

procedure TFormSysFea.BitBtnTest2Click(Sender: TObject);
begin
  TextZeile:='konsole --background-mode -e '+EditProgramm2.Text;                // Programmaufruf
  TestProgrammPlanung(Sender);
end;

procedure TFormSysFea.BitBtnTest3Click(Sender: TObject);
begin
  TextZeile:='konsole --background-mode -e '+EditProgramm3.Text;                // Programmaufruf
  TestProgrammPlanung(Sender);
//  SysUtils.ExecuteProcess(EditProgramm3.Text,'');                               // Pfadangabe erforderlich!
end;

(*--------------------------- Speichern ProgrammPlanung ----------------------*)

procedure TFormSysFea.BitBtnSpeichernPlanungClick(Sender: TObject);
begin
  abgearbeitetDatum[1]:='tt.mm.jjjj';
  abgearbeitetDatum[2]:='tt.mm.jjjj';
  abgearbeitetDatum[3]:='tt.mm.jjjj';
  SpeichernProgrammPlanung(Sender);
end;

procedure TFormSysFea.SpeichernProgrammPlanung(Sender: TObject);

  var help1, help2: String;

begin
  AssignFile(TextDatei,AktuellerPfad+'ProgrammPlanung');                        // SituationsReport auswerten

  Try
    Rewrite(TextDatei);
    Except
      ShowMessage('ProgrammPlanung-Datei kann nicht angelegt werden!'+Zeilenumbruch+
                  'Die ProgrammPlanung-Daten sind nicht erstellbar.'+Zeilenumbruch+
                  'Bitte Verzeichnisse und Rechte pruefen und nochmals versuchen!');
          StatusBar.Panels[0].Text:='Fehler: ProgrammPlanung-Datei nicht anlegbar.';
      Exit;
  end;

  TextZeile:='ProgrammPlanung-Datei bitte nicht editieren!';
  WriteLN(Textdatei,TextZeile);

  TextZeile:='Datei wird vom Programm SysFea erstelt, manipuliert und verarbeitet ><>   Datum: '+
             FormatDateTime('dd.mm.yyyy',Date);
  WriteLN(Textdatei,TextZeile);

  Textzeile:='-------------------------------------------------------------------------------------------';
  WriteLN(TextDatei,TextZeile);

  help1:=IntToStr(ComboBoxMonat1.ItemIndex);
  If Length(help1)=1 Then help1:='0'+help1;
  If CheckBoxAktiv1.State=cbChecked Then help2:='j' Else help2:='n';

  TextZeile:='[1] Tag:'+IntToStr(ComboBoxTag1.ItemIndex)+'; Monat:'+help1+
                        '; aktiv:'+help2+'; Datum:'+
                        abgearbeitetDatum[1]+'; Programm:'+EditProgramm1.Text+';';
  WriteLN(Textdatei,TextZeile);

  help1:=IntToStr(ComboBoxMonat2.ItemIndex);
  If Length(help1)=1 Then help1:='0'+help1;
  If CheckBoxAktiv2.State=cbChecked Then help2:='j' Else help2:='n';

  TextZeile:='[2] Tag:'+IntToStr(ComboBoxTag2.ItemIndex)+'; Monat:'+help1+
                        '; aktiv:'+help2+'; Datum:'+
                        abgearbeitetDatum[2]+'; Programm:'+EditProgramm2.Text+';';
  WriteLN(Textdatei,TextZeile);

  help1:=IntToStr(ComboBoxMonat3.ItemIndex);
  If Length(help1)=1 Then help1:='0'+help1;
  If CheckBoxAktiv3.State=cbChecked Then help2:='j' Else help2:='n';

  TextZeile:='[3] Tag:'+IntToStr(ComboBoxTag3.ItemIndex)+'; Monat:'+help1+
                        '; aktiv:'+help2+'; Datum:'+
                        abgearbeitetDatum[3]+'; Programm:'+EditProgramm3.Text+';';
  WriteLN(Textdatei,TextZeile);

  Textzeile:='-------------------------------------------------------------------------------------------';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='Planungs-Matrix';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='-------------------------------------------------------------------------------------------';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='Tag		Monat		Abarbeitung';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='-------------------------------------------------------------------------------------------';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='jeden		jeden	==>	taeglich';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='Wochentag	jeden	==>	gewaehlten Wochentag in allen Monaten';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='jeden		Monat	==>	einmal im Monat';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='Wochentag	Monat	==>	jeden gewaehlten Wochentag im gewaehlten Monat';
  WriteLN(TextDatei,TextZeile);
  TextZeile:='-------------------------------------------------------------------------------------------';
  WriteLN(TextDatei,TextZeile);

  CloseFile(TextDatei);
End;

initialization
  {$I Unit1.lrs}
end.

